#include <tcl.h>
#include <tk.h>
#include "tkRaster.h"

int to_int(Tcl_Interp *tcl) {
  return ((int) tcl);
}

int ConstTclOk() {
  return TCL_OK;
}

int ConstTclError() {
  return TCL_ERROR;
}

void *ConstTclVolatile() {
  return TCL_VOLATILE;
}

void delete_proc(ClientData client_data) {}

int tkkit_cb_cmd(ClientData user_data, Tcl_Interp *tcl, int argc, char **argv) {
  C_TCL_TK_tkkit_cb(argv);
}

int sather_cmd(ClientData user_data, Tcl_Interp *tcl, int argc, char **argv) {
  return C_TCL_TK_sather_cb((int) tcl, argv);
}

void init_tcl_tk(Tcl_Interp *tcl) {
  /*  Initialize the two new tcl commands tkkit_cb and sather */
  Tcl_CreateCommand(tcl, "tkkit_cb", tkkit_cb_cmd, NULL, delete_proc);
  Tcl_CreateCommand(tcl, "sather", sather_cmd, NULL, delete_proc);
}

void init_raster(Tcl_Interp *tcl) {
  /* Initialize the raster commands */
  Tk_AddRaster(tcl);
  RasterInit(tcl);
}

char *str_ind(char **argv, int i) {
  return argv[i];
}

char *Tcl_GetResult(Tcl_Interp *interpreter) {
  return interpreter->result;
}

int
Tk_AddRaster(interp)
    Tcl_Interp *interp;         /* Interpreter for application. */
{
    Tk_Window main;
 
    main = Tk_MainWindow(interp);
    if ( main == NULL ) {
      return TCL_ERROR;
    }
    if (RasterInit(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
 
    Tcl_CreateCommand(interp, "raster", RasterCmd, (ClientData) main,
            (void (*)()) NULL);
    tcl_RcFileName = "~/.wishrc";
    return TCL_OK;
}

