#ifndef _MD_ATOMIC_
#define _MD_ATOMIC_

/* 
   Until better times (when I have time to look into the multiprocessing
   version), we do not really need atomic operations here. The only trouble
   can come from DMA, but we do not allow this. Active Threads have to be
   called specifically for synchronization. 

   This will be replaced with proper atomic operations when we have a
   true multiprocessing version of Active Threads for the ALPHA AXP
*/ 	


/* 
 * Reads a value from at the address "addr" into register "r" and modifies
 * location with address "addr". The nature of the modification may be
 * different on different architectures. For now, we simply clear the
 * location (for ALPHA AXP multiprocessing version we will use the native 
 * synchronization instructions (in the future)
 */
#define MD_UNLOCKED_VAL   0
#define MD_LOCKED_VAL     1
#define MD_READ_AND_MODIFY(addr,r) r = (*addr); (*addr) = MD_LOCKED_VAL;
#define MD_OBTAINED_LOCK(r) (r==MD_UNLOCKED_VAL)
#define MD_IS_LOCKED(addr)  (*addr==MD_LOCKED_VAL)
#define MD_UNLOCK(addr)     *addr=MD_UNLOCKED_VAL;

#endif 

