#ifndef _MD_ATOMIC_H_
#define _MD_ATOMIC_H_

/* x must be an address of a word, and y must be a register local */
# define TEST_AND_SET(x,y) \
        asm volatile ("movl $1, %0" :  "=r" (y));  \
        asm volatile ("xchgl %0, 0(%1)" : "=r" (y) : "r" (x)); 
	

#define MD_UNLOCKED_VAL   0
#define MD_LOCKED_VAL     1
#define MD_READ_AND_MODIFY(addr,r) \
        asm volatile ("movl $1, %0" :  "=r" (r));  \
        asm volatile ("xchgl %0, 0(%1)" : "=r" (r) : "r" (addr)); 
#define MD_OBTAINED_LOCK(r) (r==MD_UNLOCKED_VAL)
#define MD_IS_LOCKED(addr)  (*addr==MD_LOCKED_VAL)
#define MD_UNLOCK(addr)     *addr=MD_UNLOCKED_VAL;

#endif /* _MD_ATOMIC_  */
