#ifndef _MD_ATOMIC_
#define _MD_ATOMIC_

/* addr must be an address of a word, and r must be a register local */

#define MD_UNLOCKED_VAL   0
#define MD_LOCKED_VAL     0xff000000
#define MD_READ_AND_MODIFY(addr,r) asm volatile \
     ("ldstub [%1], %0" : "=r" (r) : "r" (addr))
#define MD_OBTAINED_LOCK(r) (r==MD_UNLOCKED_VAL)
#define MD_IS_LOCKED(addr)  (*addr==MD_LOCKED_VAL)
#define MD_UNLOCK(addr)     asm volatile ("stbar"); \
     (volatile) *addr=MD_UNLOCKED_VAL;

#endif /* _MD_ATOMIC_  */
