#ifndef _BUNDLE_QUEUE_H_
#define _BUNDLE_QUEUE_H_

#include "bundle.h"
#include "spinlock.h"

typedef struct at_bundle_queue_t {
  at_bundle_t *head;
  at_bundle_t *tail;
  
  at_spinlock_t lck;  /* Protects the queue */
} at_bundle_queue_t;

extern void at_bundle_queue_init(at_bundle_queue_t *q);
extern void at_bundle_queue_put(at_bundle_queue_t *q, at_bundle_t *t);
extern void at_bundle_queue_put_at_head(at_bundle_queue_t *q,at_bundle_t *t);
extern at_bundle_t *at_bundle_queue_get(at_bundle_queue_t *q);

#endif /* _BUNDLE_QUEUE_H_ */

