#ifndef _STATE_H_
#define _STATE_H_

#include "bundle.h"
#include "thread_queue.h"
#include "bundle_queue.h"
/* 
 * A simple bundle state datastructure. Bundles can use this
 * or define anything they need and attach it to bundle_state
 */

typedef struct at_bundle_state {
  at_bundle_t *parent;
  at_thread_queue_t threads;  /* child threads */
  at_bundle_queue_t bundles;  /* child bundles */
  int thread_counter;
  int bundle_counter;
} at_bundle_state_t;

typedef struct at_mig_bundle_state {
  at_bundle_t *parent;
  at_thread_queue_t local_threads;  /* cannot migrate yet */
  at_thread_queue_t global_threads;  /* can migrate */
  at_bundle_queue_t bundles;  /* child bundles */
  int thread_counter;
  int bundle_counter;
} at_mig_bundle_state_t;

#endif /* _STATE_H_ */
