#ifndef _THREAD_QUEUE_H_
#define _THREAD_QUEUE_H_

#include "thread.h"
#include "spinlock.h"

typedef struct at_thread_queue_t {
  at_thread_t *head;
  at_thread_t *tail;
  
  at_spinlock_t lck;  /* Protects the queue */
} at_thread_queue_t;

extern void at_thread_queue_init(at_thread_queue_t *q);
extern void at_thread_queue_put(at_thread_queue_t *q, at_thread_t *t);
extern void at_thread_queue_put_at_head(at_thread_queue_t *q,at_thread_t *t);
extern at_thread_t *at_thread_queue_get(at_thread_queue_t *q);

#endif /* _THREAD_QUEUE_H_ */
