#ifndef _COND_H_
#define _COND_H_

#include "spinlock.h"
#include "mutex.h"
#include "thread.h"
/*------------------------------------------------------------------*/
/*                       Condition Variable                         */
/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/

/* For pooling, it is important for next to be the first attribute */
typedef struct at_cond {
  struct at_cond *next;   /* misc. linking */
  at_mutex_t *mx;         /* base mutex - stored here every now and then ... */
  at_thread_t*  sleepers; /* Threads waiting on the cond. variable */
  int pad;
} at_cond_t;

/* External interface */
at_cond_t *at_cond_create();
void at_cond_destroy(at_cond_t *);
void at_cond_wait(at_cond_t *c, at_mutex_t *mx);
void at_cond_signal(at_cond_t *);
void at_cond_broadcast(at_cond_t *);
void at_cond_init(at_cond_t *c);

#endif /* _COND_H_ */

