#ifndef _WRAPPERS_H_
#define _WRAPPERS_H_

#include "spinlock.h"

#define at_printf(format, args...)            \
  {                                           \
      AT_KERNEL_LOCK;                         \
      fprintf(stdout, format, ## args);       \
      fflush(stdout);                         \
      AT_KERNEL_UNLOCK;                       \
  }

#define at_fprintf(_fp_,format, args...)      \
  {                                           \
      AT_KERNEL_LOCK;                         \
      fprintf(_fp_, format, ## args);         \
      fflush(_fp_);                           \
      AT_KERNEL_UNLOCK;                       \
  }

extern at_spinlock_t kernel_lck;

extern int mem_usage;
extern int max_mem_usage;

void *at_malloc(long size);
void at_free(void *ptr);
void *at_calloc(long nelem, long elsize);
void *at_realloc(void* ptr, long size);


/* Remap all things that need serialization to their syncronized versions */
#define malloc(x)       at_malloc(x)
#define free(x)         at_free(x)
#define realloc(a,b)  at_realloc(a,b)
#define calloc(a,b)   at_calloc(a,b)
/*#define alloca(a)     at_alloc(a)*/

#endif /* _WRAPPERS_H_ */

