#include <sys/types.h>
#include <sys/time.h>

#include "at.h"

#define MAX_THREADS 1000

int concurrency = 1;
int threads = 2;
int yields = 500000;

volatile int threads_finished = 0;
at_spinlock_t lck;
/*hrtime_t start, finish;*/
clock_t start, finish;
at_mutex_t done;

void the_thread(at_word_t arg){
  int i;
  
  i = *(int *)arg;

  at_printf("# threads: %d\n", at_thread_count());

  while(i){
    i--;
    /*TNF_PROBE_0(AT_YIELD, "AT AT_YIELD AT_YIELD_start", ""); */
    at_yield();
    /*    SYNC(TNF_PROBE_0(AT_YIELD_end, "AT AT_YIELD AT_YIELD_end", ""));*/
  }

  AT_SPINLOCK_LOCK(lck);
  threads_finished++;
  AT_SPINLOCK_UNLOCK(lck);
  at_mutex_unlock(&done);
}


void main(int argc, char **argv){
  int i;
  at_bundle_t *bundle;

  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    threads = atoi(argv[2]);
  }
  if(argc>3){
    yields = atoi(argv[3]);
  }

  AT_SPINLOCK_INIT(lck);


  /*Initialize the thread package */
  at_init(concurrency, 0x2000, 0);
  at_mutex_init(&done);
  at_mutex_lock(&done);
  bundle = at_mcs_bundle_create(at_get_focus());
  at_set_focus(bundle);

  start = clock();
  for(i=0; i<threads; i++){
    at_create_1(bundle, 0, the_thread, (at_word_t)&yields);
  }

  at_mutex_lock(&done);
  finish=clock();


  at_printf("Thread context switch time  %e us\n", 
	 (double)(finish-start)/1.0e+6); 

  at_join_all();
  exit(0);
}















