#include <time.h>
#include "at.h"

int concurrency = 1;
int iterations = 1000000;

at_mutex_t *mx;

clock_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  /*Initialize the thread package */
  at_init(concurrency, 0x2000, 0);

  mx = at_mutex_create();
  
  start = clock();
  for(i=0; i<iterations; i++){
    at_mutex_lock(mx);
    at_mutex_unlock(mx);
  }
  finish = clock();
  printf("Uncontested mutex, (us): %e\n", ((double)finish - (double)start)/iterations);
  exit(0);
}





