#include <time.h>
#include "at.h"

int concurrency = 1;
int iterations = 1000000;

at_sema_t *sema;
clock_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  /*Initialize the thread package */
  at_init(concurrency, 0x2000, 0);

  sema = at_sema_create(1);
  
  start = clock();
  for(i=0; i<iterations; i++){
    at_sema_wait(sema);
    at_sema_signal(sema);
  }
  finish = clock();
  printf("Uncontested sema, us: %e\n", ((double)finish - (double)start)/iterations);
  exit(0);

}





