/* compile: cc -threads uncontested_sema.c -lrt */
#include <time.h>
#include <pthread.h>
#include <semaphore.h>

clock_t start, finish;

int concurrency = 1;
int iterations = 1000;

sem_t *sema;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }


  sema = (sem_t *)malloc(sizeof(sem_t));
  sem_init(sema, 0, 0);

  start = clock();
  for(i=0; i<iterations; i++){
    sem_post(sema);
    sem_wait(sema);
  }
  finish = clock();
  printf("Time (us): %e\n", ((double)finish - (double)start)/iterations);  
}





