#include <tnf/probe.h>
#include <thread.h>

int num_pongs = 1000;
int concurrency = 1;

mutex_t *ping_mx, *pong_mx;

void* ping_pong(void* arg){
  int i;
  
  i = *(int *)arg;
  
  while(i--){
    mutex_lock(ping_mx);
    mutex_unlock(pong_mx);
  }
}

void* pong_ping(void* arg){
  int i;
  
  i = *(int *)arg;
  
  while(i--){
    mutex_unlock(ping_mx);
    mutex_lock(pong_mx);
  }
}

void main(int argc, char **argv){
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    num_pongs = atoi(argv[2]);
  }

  /*Initialize the thread package */
  thr_setconcurrency(concurrency);

  ping_mx = (mutex_t *)malloc(sizeof(mutex_t));
  mutex_init(ping_mx, USYNC_THREAD, NULL);
  pong_mx = (mutex_t *)malloc(sizeof(mutex_t));
  mutex_init(pong_mx, USYNC_THREAD, NULL);
  
  mutex_lock(ping_mx);
  mutex_lock(pong_mx);


  thr_create(NULL, 0, ping_pong, &num_pongs, 0, NULL);

  pong_ping(&num_pongs);
  
  exit(0);
}





