#include <tnf/probe.h>
#include <thread.h>

int num_pongs = 1000;
int concurrency = 1;
hrtime_t start, finish;

sema_t *ping_sema, *pong_sema;

void* ping_pong(void* arg){
  int i;
  
  i = *(int *)arg;
  
  while(i--){
    sema_wait(ping_sema);
    sema_post(pong_sema);
  }
}

void* pong_ping(void* arg){
  int i;
  
  i = *(int *)arg;
  
  while(i--){
    sema_post(ping_sema);
    sema_wait(pong_sema);
  }
}

void main(int argc, char **argv){
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    num_pongs = atoi(argv[2]);
  }

  /*Initialize the thread package */
  thr_setconcurrency(concurrency);

  ping_sema = (sema_t *)malloc(sizeof(sema_t));
  sema_init(ping_sema, 0, USYNC_THREAD, NULL);
  pong_sema = (sema_t *)malloc(sizeof(sema_t));
  sema_init(pong_sema, 0, USYNC_THREAD, NULL);
  
  thr_create(NULL, 0, ping_pong, &num_pongs, 0, NULL);
  
  start=gethrtime();
  pong_ping(&num_pongs);
  finish=gethrtime();
  printf("Time  %e us\n", 
	 (double)(finish-start)/(1000.0));
  exit(0);
}





