/*									tab:8
 *
 * ifc.h - Lanai Control Program / Host interface .
 *
 * 
 * "Copyright (c) 1995 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 		Richard P. Martin and Lok T. Liu
 * Version:		49
 * Creation Date:	Sun Feb  5 21:46:21 1995
 * Filename:		ifc.h
 * History:             
 */

#define E2L		1
#define L2E  		0

#define H_DEBUG_GO_P      0xf203    /* lanai done init */
#define L_INIT_DONE_P     0xf204    /* lanai done init */
#define H_INIT_DONE_P     0xf205    /* host done init */
#define H_DMA_STS_P       0xf206    /* proper DMA register value */ 
#define ROUTE_TAB_P       0xf207    /* route table base address  */
#define IN_BASE_P         0xf208    /* in descriptor base address  */
#define OUT_BASE_P        0xf209    /* out table base address  */
#define BULK_PTR_P        0xf20a    /* base pointer of pointer for recv DMA*/
#define P_END_PT_P        0xf20b    /* base pointer for private endpoint  */
#define AM_INTR_P          0xf211    /* checked by recv thread to send inter */

#ifdef LANAI
#define H_DEBUG_GO    *((volatile short *) H_DEBUG_GO_P)
#define L_INIT_DONE   *((volatile short *) L_INIT_DONE_P)
#define H_INIT_DONE   *((volatile short *) H_INIT_DONE_P)
#define H_DMA_STS     *((volatile short *) H_DMA_STS_P)
#define ROUTE_TAB  *((volatile short *)  ROUTE_TAB_P)
#define IN_BASE    *((volatile short *)  IN_BASE_P)
#define OUT_BASE   *((volatile short *)  OUT_BASE_P)
#define BULK_PTR   *((volatile short *)  BULK_PTR_P)
#define P_END_PT   *((volatile short *)  P_END_PT_P)
#define AM_INTR     *((volatile short *) AM_INTR_P)    

#else /* host */

#define H_DEBUG_GO     LANAI[unit][H_DEBUG_GO_P]
#define L_INIT_DONE    LANAI[unit][L_INIT_DONE_P]
#define H_INIT_DONE    LANAI[unit][H_INIT_DONE_P]
#define H_DMA_STS      LANAI[unit][H_DMA_STS_P]
#define ROUTE_TAB    LANAI[unit][ROUTE_TAB_P ]
#define IN_BASE      LANAI[unit][IN_BASE_P]
#define OUT_BASE     LANAI[unit][OUT_BASE_P]
#define BULK_PTR     LANAI[unit][BULK_PTR_P]
#define P_END_PT     LANAI[unit][P_END_PT_P]
#define AM_INTR      LANAI[unit][AM_INTR_P]
#endif

#define TRUE    1
#define FALSE   0





