

/*************************************************************************
 *                                                                       *
 * Myricom Myrinet Software                                              *
 *                                                                       *
 * Copyright (c) 1994 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *                                                                       *
 * This software is released under a non-disclosure agreement with       *
 * Myricom, Inc. Redistribution in any form is strictly prohibited.      *
 *                                                                       *
 * Myricom, Inc. makes no representations about the suitability of this  *
 * software for any purpose.                                             *
 *                                                                       *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING  *
 * THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A           *
 * PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR     *
 * TRADE PRACTICE. MYRICOM, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO *
 * THE INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS  *
 * FILE OR ANY PART THEREOF.                                             *
 *                                                                       *
 * In no event will Myricom, Inc. be liable for any lost revenue         *
 * or profits or other special, indirect and consequential damages, even *
 * if Myricom has been advised of the possibility of such damages.       *
 *                                                                       *
 *                                                                       *
 * Other copyrights might apply to parts of this software and are so     *
 * noted when applicable.                                                *
 *                                                                       *
 * Myricom, Inc.                                                         *
 * 325 N. Santa Anita Ave.                                               *
 * Arcadia, CA 91006                                                     *
 *                                                                       *
 *************************************************************************/


/* LANai2.0 */


#ifndef LANAI_DEV_H
#define LANAI_DEV_H 1

#ifdef lint
extern unsigned  ISR
extern unsigned  IMR
extern unsigned  CCR
extern unsigned  RP
extern unsigned  RML
extern unsigned  RMP
extern unsigned  SMP
extern unsigned  SML
extern unsigned  SMLT
extern unsigned  PC
extern unsigned  APC
extern int      *SP;
extern int      *BP;
#else
/*
register junk8 	asm ("r8"); 
register junk9 	asm ("r9");
register junk10 asm ("r10");
register junk11 asm ("r11");
register junk12 asm ("r12");
register junk13	asm ("r13");
register junk14 asm ("r14");
register junk15 asm ("r15");
*/

volatile register unsigned ISR 	asm ("isr");
volatile register unsigned IMR 	asm ("imr");
volatile register unsigned SBT 	asm ("sbt");
volatile register unsigned CCR 	asm ("ccr");
volatile register unsigned RP 		asm ("rp");
register unsigned 	   RML 	asm ("rml");
volatile register unsigned RMP 	asm ("rmp");
volatile register unsigned SMP 	asm ("smp");
register unsigned 	   SML 	asm ("sml");
register unsigned  	   SMLT 	asm ("smlt");
volatile register unsigned PC 		asm ("pc");
volatile register unsigned APC 	asm ("apc");
register	  int      *SP 		asm ("sp");
/*
register 	  int      *BP 		asm ("bp");
*/
#endif
/*
w  FFFF  =>  led                r    FFEF  =>  rb
w  FFFE  =>  int                r    FFEE  =>  rw
w  FFFD  =>  sb                 r/w  FFED  =>  rtcm
w  FFFC  =>  sw                 r/w  FFEC  =>  rtcl
w  FFFB  =>  sbt                r/w  FFEB  =>  it
w  FFFA  =>  swt                r/w  FFEA  =>  earm
w  FFF9  =>  dma_sts            r/w  FFE9  =>  earl
w  FFF8  =>  dma_dir            r/w  FFE8  =>  lar
w  FFF7  =>  fres               r/w  FFE7  =>  dma_ctr
w  FFF6  =>  stop_go            r/w  FFE6  =>  cksm
w  FFF5  =>  sa                 r/w  FFE5  =>  cksl
w  FFF4  =>  crc
*/


#define LED     (*((volatile int *) 0xFFFF))
#define INT     (*((volatile int *) 0xFFFE))
#define SB      (*((volatile int *) 0xFFFD))
#define SH      (*((volatile int *) 0xFFFC))
#define SBT     (*((volatile int *) 0xFFFB))
#define SHT     (*((volatile int *) 0xFFFA))
#define DMA_STS (*((volatile int *) 0xFFF9))
#define DMA_DIR (*((volatile int *) 0xFFF8))
#define FRES    (*((volatile int *) 0xFFF7))
#define STOP_GO (*((volatile int *) 0xFFF6))
#define SA      (*((volatile int *) 0xFFF5))
#define CRC     (*((volatile int *) 0xFFF4))

#define RB      (*((volatile int *) 0xFFEF))
#define RH      (*((volatile int *) 0xFFEE))
#define RTCM    (*((volatile int *) 0xFFED))
#define RTCL    (*((volatile int *) 0xFFEC))
#define IT      (*((volatile int *) 0xFFEB))
#define EARM    (*((volatile int *) 0xFFEA))
#define EARL    (*((volatile int *) 0xFFE9))
#define LAR     (*((volatile int *) 0xFFE8))
#define DMA_CTR (*((volatile int *) 0xFFE7))
#define CKSM    (*((volatile int *) 0xFFE6))
#define CKSL    (*((volatile int *) 0xFFE5))


#define LONG_RDY_BIT    0x8000
#define HALF_RDY_BIT    0x4000
#define SEND_RDY_BIT    0x2000
#define LINK_INT_BIT	0x1000
#define FRES_INT_BIT	0x800
#define WAKE_INT_BIT	0x400
#define OFF_BY_2_BIT	0x200
#define OFF_BY_1_BIT	0x100
#define TAIL_INT_BIT    0x80
#define WDOG_INT_BIT	0x40
#define TIME_INT_BIT	0x20
#define DMA_INT_BIT	0x10
#define SEND_INT_BIT 	0x8
#define BUFF_INT_BIT 	0x4
#define RECV_INT_BIT 	0x2
#define BYTE_RDY_BIT    0x1

#define ORUN2_BIT	OFF_BY_2_BIT
#define ORUN1_BIT	OFF_BY_1_BIT

#define clear_HALF_RDY_BIT()   	do { asm ("mov #0x4000, isr"); } while (0)
#define clear_SEND_RDY_BIT() 	do { asm ("mov #0x2000, isr"); }  while (0)
#define clear_LINK_INT_BIT()	do {  asm ("mov #0x1000, isr"); } while (0)
#define clear_FRES_INT_BIT()	do {  asm ("mov #0x800, isr"); } while (0)
#define clear_WAKE_INT_BIT()	do {  asm ("mov #0x400, isr"); } while (0)
#define clear_OFF_BY_2_BIT()	do {  asm ("mov #0x200, isr"); } while (0)
#define clear_OFF_BY_1_BIT()	do {  asm ("mov #0x100, isr"); } while (0)
#define clear_ORUN2_BIT()	do {  asm ("mov #0x200, isr"); } while (0)
#define clear_ORUN1_BIT()	do {  asm ("mov #0x100, isr"); } while (0)
#define clear_TAIL_INT_BIT()   	do {  asm ("mov #0x80, isr"); } while (0)
#define clear_WDOG_INT_BIT()	do {  asm ("mov #0x40, isr"); } while (0)
#define clear_TIME_INT_BIT()	do {  asm ("mov #0x20, isr"); } while (0)
#define clear_DMA_INT_BIT()	do {  asm ("mov #0x10, isr"); } while (0)
#define clear_SEND_INT_BIT()	do {  asm ("mov #0x8, isr"); } while (0)
#define clear_BUFF_INT_BIT()	do {  asm ("mov #0x4, isr"); } while (0)
#define clear_RECV_INT_BIT()	do {  asm ("mov #0x2, isr"); } while (0)
#define clear_BYTE_RDY_BIT()  	do {  asm ("mov #0x1, isr"); } while (0) 

#define RECV_RDY_BITS	(BYTE_RDY_BIT | HALF_RDY_BIT | LONG_RDY_BIT)


#define ACK_SEND (ISR = ISR&(SEND_BIT))
#define ACK_RECV (ISR = ISR&(RECV_BIT))
#define ACK_BUFF (ISR = ISR&(RECV_BIT))

#define START_USER(LOC) { extern int LOC asm("LOC"); \
                          APC = (int) &LOC; \
                          asm("punt"); }

#define USER_ENTRY(LOC) asm("LOC:")


#define RESUME_USER   asm("punt")
#define RESUME_SYSTEM asm("punt")


extern void reset_Myrinet_ifc();
#endif
